import { Module } from '@nestjs/common';
import { MailerController } from './controller/mailer.controller';
import { MailerService } from './service/mailer.service';
import { DatabaseModule } from '../database/database.module';
import { channelMatchingProvider, productMatchingProvider } from './provider/channelJCT.provider';

@Module({
  imports: [DatabaseModule],
  controllers: [MailerController],
  providers: [MailerService, ...channelMatchingProvider, ...productMatchingProvider]
})
export class MailerModule { }
