import { Table, Column, PrimaryKey, Model, AutoIncrement, DataType, AllowNull, ForeignKey, HasOne, HasMany, Scopes, BelongsTo, BelongsToMany, AfterUpdate, AfterBulkUpdate } from 'sequelize-typescript';
import { IDefineOptions } from 'sequelize-typescript/node_modules/glob';
import { DataTypes } from 'sequelize/types';

const tableOptions: IDefineOptions = { timestamps: false, tableName: 'tblChannelMatching' } as IDefineOptions;

@Table(tableOptions)



export class ChannelMatching extends Model<ChannelMatching>{

    @PrimaryKey
    @AutoIncrement
    @AllowNull(false)
    @Column(DataType.BIGINT)
    channelMatchingId: number;

    @Column(DataType.BIGINT)
    channelId: number;

    @Column(DataType.BIGINT)
    partnerChannelId: number;

    @Column(DataType.BIGINT)
    request_to: number;

    @Column(DataType.BIGINT)
    request_by: number;

    @Column(DataType.DATE)
    createdAt: Date;

    @Column(DataType.DATE)
    deletedAt: Date;

    @Column
    mailStatus: string;
}
